Subject: [magma] Query on querier version in IGMPv3

From: Bharat Joshi <[email-masked]>
Date: Mon, 19 Jul 2010 10:39:50 +0530

Hi All,

      I was re-reading RFC 3376 for handling compatibility for lower version of querier.

      In section 7.3.1, it is mentioned that a querier configured to run in V3 mode
      should lower its version when it sees a lower version query on the same
      network. From that time onwards, a router should send the lower version
      queries.

      Now the question is, when this router should revert back to its configured higher
      version? The text in section 7.3.1 or elsewhere does not talk about this.

      Should a timer 'lower_version_querier' be started and updated as and when lower
      version queries are removed? Please note this is not same as other-querier-present
      timer.

      Can someone, who has implemented IGMPv3, let me know how this particular case
      has been handled in their implementation?

Regards,
Bharat
**************** CAUTION - Disclaimer *****************
This e-mail contains PRIVILEGED AND CONFIDENTIAL INFORMATION intended solely 
for the use of the addressee(s). If you are not the intended recipient, please 
notify the sender by e-mail and delete the original message. Further, you are not 
to copy, disclose, or distribute this e-mail or its contents to any other person and 
any such actions are unlawful. This e-mail may contain viruses. Infosys has taken 
every reasonable precaution to minimize this risk, but is not liable for any damage 
you may sustain as a result of any virus in this e-mail. You should carry out your 
own virus checks before opening the e-mail or attachment. Infosys reserves the 
right to monitor and review the content of all messages sent to or from this e-mail 
address. Messages sent to or from this e-mail address may be stored on the 
Infosys e-mail system.
***INFOSYS******** End of Disclaimer ********INFOSYS***

---

From: Indranil Bhattacharya <[email-masked]>
Date: Mon, 19 Jul 2010 13:43:49 +0530

Hi Bharat,

              Do not lower the querier version. Let the v2 updates's it
querier timer from v3 query or let it use it's configured query interval.
Otherwise, the reselection can happen after every General query.

Thanks,
Indranil

On Mon, Jul 19, 2010 at 10:39 AM, Bharat Joshi <[email-masked]>wrote:

> _______________________________________________
> magma mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/magma
>

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 19 Jul 2010 13:45:23 +0530

Indranil,

     Ok. But RFC 3376 clearly says that a router should lower its version to the lowest version of query heard on a network. 

     One thing I did not get in your reply is 'Let the v2 updates's it querier timer from v3 query...'. While second part of this statement is clear, I am not sure about the first part. A version 2 querier may/may not support V3 so things won't work any way and there will be multiple number of queries on network which may not be desirable.

     Another thing I did not understand is the last sentence. What do you mean by 'reselection can happen after every general query'? I think RFC 3376 suggested this to avoid multiple queries on a network. If a router do what is suggested in RFC 3376, at least there will be only one query in the network.

     I checked couple of open-source implementation and it seems none of them store this information and always use the highest configured version to send out an IGMP query. Not sure if there was any specific reason for not doing this.

Regards,
Bharat
________________________________________
From: Indranil Bhattacharya [[email-masked]]
Sent: Monday, July 19, 2010 1:43 PM
To: Bharat Joshi
Cc: [email-masked]
Subject: Re: [magma] Query on querier version in IGMPv3

Hi Bharat,

              Do not lower the querier version. Let the v2 updates's it querier timer from v3 query or let it use it's configured query interval. Otherwise, the reselection can happen after every General query.

Thanks,
Indranil

On Mon, Jul 19, 2010 at 10:39 AM, Bharat Joshi <[email-masked]<mailto:[email-masked]>> wrote:
Hi All,

Regards,
Bharat
[email-masked]<mailto:[email-masked]>

---

From: Indranil Bhattacharya <[email-masked]>
Date: Mon, 19 Jul 2010 14:51:07 +0530

Hi Bharat,

              The first part is applicable to a router which has v3 but has
been configured as v2.

               The 'reselection' part was an answer for when the router
should revert back to the configured higher query version. This will
be done when transmitting general query. After that if it receives v2/v1
query then it will lower the version again. Even if you take the new timer
approach, problem is that how do you control sequence of queries from
routers? Say, after timer expiry version is changed and v3 GQ is sent. V2
non-querier does not understand v3 query so it sends v2 GQ.

                Section 7.3.1 says that it is an administrative
responsibility. Excerpt is given below:
"If any older versions of IGMP are present on routers, the querier
     MUST use the lowest version of IGMP present on the network.  This
     must be administratively assured; routers that desire to be
     compatible with IGMPv1 and IGMPv2 MUST have a configuration option
     to act in IGMPv1 or IGMPv2 compatibility modes."

Thanks,
Indranil

On Mon, Jul 19, 2010 at 1:45 PM, Bharat Joshi <[email-masked]>wrote:

> Indranil,
>
>     Ok. But RFC 3376 clearly says that a router should lower its version to
> the lowest version of query heard on a network.
>
>     One thing I did not get in your reply is 'Let the v2 updates's it
> querier timer from v3 query...'. While second part of this statement is
> clear, I am not sure about the first part. A version 2 querier may/may not
> support V3 so things won't work any way and there will be multiple number of
> queries on network which may not be desirable.
>
>     Another thing I did not understand is the last sentence. What do you
> mean by 'reselection can happen after every general query'? I think RFC 3376
> suggested this to avoid multiple queries on a network. If a router do what
> is suggested in RFC 3376, at least there will be only one query in the
> network.
>
>     I checked couple of open-source implementation and it seems none of
> them store this information and always use the highest configured version to
> send out an IGMP query. Not sure if there was any specific reason for not
> doing this.
>
> Regards,
> Bharat
>  On Mon, Jul 19, 2010 at 10:39 AM, Bharat Joshi <[email-masked]
> <mailto:[email-masked]>> wrote:
> Hi All,
>

---

From: Bharat Joshi <[email-masked]>
Date: Mon, 19 Jul 2010 15:11:17 +0530

Indranil,

      Thanks for your reply.

      For the reselection part, using a timer will take care of the issue, you are suggesting could be there. The lower_version_querier timeout will be twice the query-interval + robustness count, which will make sure that timer fires only when the lowest version querier does not send any query message for such a time. ( Now someone can argue that query-interval for the lower version querier might be huge and it may not send any query during this period. I think this is a mis-configuration and this can result in other issue. Also the same issue exist in querier election as well. So we should not worry about this at all. )

      For the administrative part, I agree that a router which is configured with V3 has to be configured administratively to process V2/V1 queries. Basically an administrator is suggesting that a particular interface may have old version querier and if that happens,  lower our own version of queries in that interface. But I am still not sure how to bring it back to the old higher version?

Regards,
Bharat
________________________________________
From: Indranil Bhattacharya [[email-masked]]
Sent: Monday, July 19, 2010 2:51 PM
To: Bharat Joshi
Cc: [email-masked]
Subject: Re: [magma] Query on querier version in IGMPv3

Hi Bharat,

              The first part is applicable to a router which has v3 but has been configured as v2.

               The 'reselection' part was an answer for when the router should revert back to the configured higher query version. This will be done when transmitting general query. After that if it receives v2/v1 query then it will lower the version again. Even if you take the new timer approach, problem is that how do you control sequence of queries from routers? Say, after timer expiry version is changed and v3 GQ is sent. V2 non-querier does not understand v3 query so it sends v2 GQ.

                Section 7.3.1 says that it is an administrative responsibility. Excerpt is given below:

Thanks,
Indranil

On Mon, Jul 19, 2010 at 1:45 PM, Bharat Joshi <[email-masked]<mailto:[email-masked]>> wrote:
Indranil,

Regards,
Bharat
________________________________________
From: Indranil Bhattacharya [[email-masked]<mailto:[email-masked]>]
Sent: Monday, July 19, 2010 1:43 PM
To: Bharat Joshi
Cc: [email-masked]<mailto:[email-masked]>
Subject: Re: [magma] Query on querier version in IGMPv3

Hi Bharat,

Thanks,
Indranil

On Mon, Jul 19, 2010 at 10:39 AM, Bharat Joshi <[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>> wrote:
Hi All,

Regards,
Bharat
[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>

---

From: Kunal Shah <[email-masked]>
Date: Mon, 19 Jul 2010 17:57:52 -0400

Hi Bharat,

Well, if the administrator has manually configured the interface to a lower version then s/he should make the call to reconfigure to a higher version after a determination that a lower version on the interface is not required.

Kunal 

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Bharat Joshi
Sent: Monday, July 19, 2010 2:41 AM
To: Indranil Bhattacharya
Cc: [email-masked]
Subject: Re: [magma] Query on querier version in IGMPv3

Indranil,

      Thanks for your reply.

Regards,
Bharat

Hi Bharat,

Thanks,
Indranil

Regards,
Bharat

Hi Bharat,

Thanks,
Indranil

Regards,
Bharat
**************** CAUTION - Disclaimer ***************** This e-mail contains PRIVILEGED AND CONFIDENTIAL INFORMATION intended solely for the use of the addressee(s). If you are not the intended recipient, please notify the sender by e-mail and delete the original message. Further, you are not to copy, disclose, or distribute this e-mail or its contents to any other person and any such actions are unlawful. This e-mail may contain viruses. Infosys has taken every reasonable precaution to minimize this risk, but is not liable for any damage you may sustain as a result of any virus in this e-mail. You should carry out your own virus checks before opening the e-mail or attachment. Infosys reserves the right to monitor and review the content of all messages sent to or from this e-mail address. Messages sent to or from this e-mail address may be stored on the Infosys e-mail system.
***INFOSYS******** End of Disclaimer ********INFOSYS*** _______________________________________________
magma mailing list
[email-masked]<mailto:[email-masked]><mailto:[email-masked]<mailto:[email-masked]>>
https://www.ietf.org/mailman/listinfo/magma